%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Switches Component
%
% Algebraic Specification
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Component Switches
Sort: {On, Off, Usv}
Variables: switch1, switch2, switch3
Invariant: 

	% One, tells if exists one 
	% switch with the value given.
One(On) => switch1=On | switch2=On | switch3=On,
One(Off) => switch1=Off | switch2=Off | switch3=Off,
One(Usv) => switch1=Usv | switch2=Usv | switch3=Usv,

	% Definicao do predicado All
	% All, tells if all the  
	% switches have the value given.
	% Attention: the proposition All(Usv) isn't
	% defined, so it's false.
switch1=On & switch2=On & switch3=On => All(On),
switch1=Off & switch2=Off & switch3=Off => All(Off)


Method: Init
Interface: ?InitSwitch
Requires: 
	?InitSwitch=On | ?InitSwitch=Off, 
	switch2=On
Ensures:
?InitSwitch=On & switch2=On ->
   true => switch1=On, 
   true => switch2=On, 
   true => switch3=On; 
?InitSwitch=Off & switch2=On ->
   true => switch1=Off, 
   true => switch2=Off, 
   true => switch3=Off;

	% If all the switches have the same value
	% it returns this value; else it returns Usv
	% if all the switches have different values.
Method: DisplayAll
Interface: !value 
Requires: <x:All(x) | >x:One(x)
Ensures:
All(On) ->
   true => !value=On;
All(Off) ->
   true => !value=Off;
>x:One(x) ->
   true => !value=Usv;

	% switch2 gets the value from ?s2;
	% and put all the switches with different value;
	% and returns the final value of switch1.
Method: PutAllTypes
Interface: ?s2, !s1 
Requires: <x:All(x)
Ensures:
<x:All(x) ->
   switch1=On => !s1=On,
   switch1=Off => !s1=Off,
   switch1=Usv => !s1=Usv,
   
   ?s2=On => switch2=On,
   ?s2=Off => switch2=Off,
   ?s2=Usv => switch2=Usv,
   
   true => >x:One(x); 








